// $Id: views_bookmark.js,v 1.1.2.6 2007/07/14 22:32:22 quicksketch Exp $
if (Drupal.jsEnabled) {
  $(document).ready(function () {

    // Helper function for flipping the bookmark link contents.
    function flipLink(element, settings) {
      // Get the current status by reading the class names.
      var current_class = $(element).attr('class');
      if (current_class.indexOf('views-bookmark-mark ') == -1) {
        // Add the mark link.
        var new_link = $(settings.mark);
        new_link.bind('click', settings, bookmark_click);
        $(element).after(new_link);
      }
      else {
        // Add the unmark link.
        var new_link = $(settings.unmark);
        new_link.bind('click', settings, bookmark_click);
        $(element).after(new_link);
      }
      // Remove the previous link from the DOM.
      $(element).remove();
    }

    // Click function for each views bookmark link.
    var bookmark_click = function (event) {
      var element = this;
      var settings = event.data;

      // Remove the destination parameter.
      if (Drupal.settings.views_bookmark.clean_url == '1') {
        var request_url = this.href.slice(0, this.href.lastIndexOf('?')) + '/1';
      }
      else {
        var request_url = this.href.slice(0, this.href.indexOf('&') + '/1');
      }

      // Send POST request
      $.ajax({
        type: 'POST',
        url: request_url,
        data: '',
        dataType: 'json',
        success: function (data) {
          // Display errors
          if (!data.status) {
            // Change link back
            flipLink(element, settings);
            return;
          }
        },
        error: function (xmlhttp) {
          alert('An HTTP error '+ xmlhttp.status +' occured.\n'+ element.href);
          // Change link back
          flipLink(element, settings);
        }
      });
      // Swap out the links.
      flipLink(element, settings);
      return false;
    }

    // On load, bind the click behavior for all links on the page.
    for (i in Drupal.settings.views_bookmark.bookmarks) {
      var settings = Drupal.settings.views_bookmark.bookmarks[i];
      $('a.links_bookmark_'+ i).bind('click', settings, bookmark_click);
    }
  });
}